module Fox
  #
  # The FXScrollWindow widget scrolls an arbitrary child window.
  # Use the scroll window when parts of the user interface itself
  # need to be scrolled, for example when applications need to run
  # on small screens.
  #
  class FXScrollWindow < FXScrollArea
    #
    # Return an initialized FXScrollWindow instance.
    #
    # ==== Parameters:
    #
    # +p+::	the parent window for this scroll window [FXComposite]
    # +opts+::	the options [Integer]
    # +x+::	initial x-position, when the +LAYOUT_FIX_X+ layout hint is in effect [Integer]
    # +y+::	initial y-position, when the +LAYOUT_FIX_Y+ layout hint is in effect [Integer]
    # +w+::	initial width, when the +LAYOUT_FIX_WIDTH+ layout hint is in effect [Integer]
    # +h+::	initial height, when the +LAYOUT_FIX_HEIGHT+ layout hint is in effect [Integer]
    #
    def initialize(p, opts=0, x=0, y=0, w=0, h=0) # :yields: theScrollWindow
    end
  
    #
    # Return a reference to the contents window (an FXWindow instance).
    #
    def contentWindow; end
  end
end

