/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001-2003 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

%ignore FXRegion::bounds(FXRectangle& r) const;

#ifdef SWIGRUBY
%rename("empty?") FXRegion::empty() const;


%ignore FXRegion::operator=(const FXRegion& r);
%ignore FXRegion::operator+=(const FXRegion& r);
%ignore FXRegion::operator*=(const FXRegion& r);
%ignore FXRegion::operator-=(const FXRegion& r);
%ignore FXRegion::operator^=(const FXRegion& r);
%ignore FXRegion::operator!=(const FXRegion& r);

%ignore operator+(const FXRegion& r1,const FXRegion& r2);
%ignore operator*(const FXRegion& r1,const FXRegion& r2);
%ignore operator-(const FXRegion& r1,const FXRegion& r2);
%ignore operator^(const FXRegion& r1,const FXRegion& r2);
%ignore operator==(const FXRegion& r1,const FXRegion& r2);
%ignore operator!=(const FXRegion& r1,const FXRegion& r2);
#endif

%include "FXRegion.h"

%extend FXRegion {
  // Return bounding box
  FXRectangle bounds() const {
    FXRectangle r;
    self->bounds(r);
    return r;
  }

  // Union region r with this one
  FXRegion operator+(const FXRegion& other) const {
    return (*self) + other;
  }

  // Intersect region r with this one
  FXRegion operator*(const FXRegion& other) const {
    return (*self) * other;
  }

  // Subtract region r from this one
  FXRegion operator-(const FXRegion& other) const {
    return (*self) - other;
  }

  // Xor region r with this one
  FXRegion operator^(const FXRegion& other) const {
    return (*self)^other;
  }

  // Return TRUE if region equal to this one
  FXbool operator==(const FXRegion& other) const {
    return (*self) == other;
  }

#ifdef SWIGPYTHON
  FXbool operator!=(const FXRegion& other) const {
    return (*self) != other;
  }
#endif
}
