/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001-2003 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/


/**
* The scroll window widget scrolls an arbitrary child window.
* Use the scroll window when parts of the user interface itself
* need to be scrolled, for example when applications need to run
* on small screens. 
*/
class FXScrollWindow : public FXScrollArea {
protected:
  FXScrollWindow(){}
  virtual void layout();
public:
  long onKeyPress(FXObject*,FXSelector,void* PTR_EVENT);
  long onKeyRelease(FXObject*,FXSelector,void* PTR_EVENT);
  long onFocusSelf(FXObject*,FXSelector,void* PTR_EVENT);
public:

  /// Construct a scroll window
  %extend {
    FXScrollWindow(FXComposite* p,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0){
      return new FXRbScrollWindow(p,opts,x,y,w,h);
      }
    }

  /// Return a pointer to the contents window
  FXWindow* contentWindow() const;
  
  /// Destructor
  virtual ~FXScrollWindow();
  };


DECLARE_FXOBJECT_VIRTUALS(FXScrollWindow)
DECLARE_FXID_VIRTUALS(FXScrollWindow)
DECLARE_FXDRAWABLE_VIRTUALS(FXScrollWindow)
DECLARE_FXWINDOW_VIRTUALS(FXScrollWindow)
DECLARE_FXSCROLLAREA_VIRTUALS(FXScrollWindow)

