/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001-2003 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/


/// X Pixmap icon
class FXXPMIcon : public FXIcon {
protected:
  FXXPMIcon(){}
public:

  /// Construct icon from compiled-in X Pixmap format
  %extend {
    FXXPMIcon(FXApp* a,const FXchar **pix=NULL,FXColor clr=0,FXuint opts=0,FXint w=1,FXint h=1){
      return new FXRbXPMIcon(a,pix,clr,opts,w,h);
      }
    }

  /// Destroy icon
  virtual ~FXXPMIcon();
  };


DECLARE_FXOBJECT_VIRTUALS(FXXPMIcon)
DECLARE_FXID_VIRTUALS(FXXPMIcon)
DECLARE_FXDRAWABLE_VIRTUALS(FXXPMIcon)
DECLARE_FXIMAGE_VIRTUALS(FXXPMIcon)


/// Load an X Pixmap from array of strings
// extern FXbool fxloadXPM(const FXchar **pix,FXuchar*& data,FXColor& transp,FXint& width,FXint& height); FIXME


%inline %{
  /// Load an X Pixmap file from a stream
  VALUE fxloadXPM(FXStream& store){
    FXuchar* data;
    FXColor transp;
    FXint width;
    FXint height;
    if(fxloadXPM(store,data,transp,width,height)){
      VALUE ary=rb_ary_new();
      rb_ary_push(ary,rb_str_new((const char*)data,3*width*height));
      FXFREE(&data);
      rb_ary_push(ary,to_ruby(transp));
      rb_ary_push(ary,to_ruby(width));
      rb_ary_push(ary,to_ruby(height));
      return ary;
      }
    else{
      return Qnil;
      }
    }
%}


/// Save an X Pixmap file to a stream
FXbool fxsaveXPM(FXStream& store,const FXuchar *PIXELS,FXColor transp,FXint width,FXint height);
